<?php
echo "<h2>Modules Development</h2><h3>PHP-Nuke 5.5 and above</h3>\n"
	."Here's the fun bit. This is where I give you a lesson in Module Development 101.<br><br>\n"
	."What I'm going to be covering is what needs to be in every module script, whether it's something\n"
	."as basic as just displaying some static HTML code, or whether it's going to be a fully fledged -\n"
	."database accessing, all singing, all dancing spectacular of a module. Other than the necesseties,\n"
	."what's in it is up to you.<br><br>\n";
OpenTable();
echo "<h3>The Beginning</h3>The first thing you need to do, when writing a module, is start the file. The\n"
	."file should be started with the following tag:<br><br><b>< ?php </b><br><br>\n"
	."Normally, people use comments to display the title of their module, their name or alias, and their web site\n"
	."before they start writing code. This is generally accepted as common practice as part of the copyright information. e.g.<br><br>\n"
	."/**********************************************/<br>\n"
	."/* Example Module&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;*/<br>\n"
	."/* Your Name&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;*/<br>\n"
	."/**********************************************/<br><br>\n"
	."The next thing that appears in ALL modules, is the following line......<br><br>\n"
	."<b>if(!eregi(\"modules.php\", \$PHP_SELF)) {<br>\n"
	."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;die(\"You can't access this file directly\")<br>\n"
	."}</b><br><br>and<br><br><b>if(!isset(\$mainfile)){<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;include(\"mainfile.php\");<br>}</b><br><br>\n";
CloseTable();
echo "<br>\n";
OpenTable();
echo "<h3>Creating Pages</h3>\n"
	."There are 3 ways of creating pages for modules when writing in PHP. The most obvious way is to do it like you would in HTML and create a new\n"
	."file for each page that you want to display, and use a link ending like <b>Module_Name&file=FileName</b>. Each of these files must call the\n"
	."modules.php, the mainfile.php as was shown in the last section, and each file must include the line <br><br><b>include(\"header.php\");</b>\n"
	."<br><br>which calls the header of the site, and the left blocks to be shown. This line <b>MUST</b> appear before any content is added to the\n"
	."page itself.<br><br>The Second way of creating pages is to use functions. Functions are a little more complicated than files to create, because each\n"
	."one still has to call the header.php using the line I just mentioned above, and also, you have to have a preset function called \"Switch\" in\n"
	."the file as well. This function tells the module what to do when somebody calls a function using a link like <b>modules.php?name=Module_Name&op=function</b><br><br>\n"
	."op can be substituted for another word when you open the switch function. All you have to do is use this:<br><br><b>switch(\$op){</b>\n"
	."<br><br>and change <b>\$op</b> for whatever you wish to change it to. No spaces allowed.\n"
	."<br><br>Inside the switch function, you have to define all the page functions on your module. This is shown in this example:<br><br>\n"
	."<b>switch(\$op){<br><br>default:<br>default_function();<br>break;<br><br>case \"Function_1\":<br>Function_1();<br>break;<br>}</b><br><br>\n"
	."As you can see, a default option was assigned. This is the function that the module loads when it's first opened.<br><br>\n"
	."The last method of creating pages is a mix of the first 2. You create each page in a separate file, but in the index.php file you have a function\n"
	."that calls each of these page in using the include(\"pagename.php\"); command.<br><br>\n"
	."The other thing that you must have in each page is a call to footer.php using:<br><br><b>include(\"footer.php\");</b><br><br>\n";
CloseTable();
echo "<br>\n";
OpenTable();
echo "<h3>Displaying Content in PHP-Nuke modules</h3>\n"
	."The specifics of how you decide to display any content in your module is up to you, so I'll just mention a couple of basics.<br><br><u><b>Using HTML code in .php files</b></u><br>\n"
	."To use HTML code in the .php file, you have to enclose it in the echo command. e.g.<br><br><b>echo \"html code goes here, all tags are valid\\n\";</b><br><br>\n"
	."<u><b>Calling functions that contain content to display</b></u><br><br>\n"
	."Calling a function is easy. All you have to do is use the following code:<br><br><b>functionname();</b><br><br>\n"
	."If that function contains the header and footer includes, then it's essentially a page, so use the link I mentioned before, i.e.<br><br>\n"
	."<b>modules.php?name=Module_Name&op=functionname</b><br><br>\n"
	."If you've set up the switches correctly, then it'll open that page for you.<br><br>\n"
	."<u><b>Not all functions are pages</b></u><br><br>\n"
	."Some functions contain content - the menus for this guide for example - but are not pages. These are functions that get called by pages\n"
	."because having content in 1 function is better than replicating that content in every function that it has to appear in. These functions <b>DO NOT</b> include the header and footer<br><br>\n"
	."<u><b>Using Tables to display content</b></u><br><br>\n"
	."Most modules use tables to display the content. There are 2 functions in every theme that are used most commonly, these are:<br><br>\n"
	."<b>OpenTable();</b> and <b>OpenTable2();</b> which have to be closed with <b>CloseTable();</b> and <b>CloseTable2();</b> respectively<br><br>\n"
	."You can open tables within tables which is what I did for this guide. each page has 3 main tables on it, with more tables containing information inside like this page has on the larger pages<br><br>\n";
CloseTable();
echo "<br><br>That's the basics of module design. The rest is up to you. Have fun.<br>\n";
?>